from byugrid import Grid
from lifeutils import make_alive


# Stable formations


def block():
    return Grid.build([[None, None, None, None],
                       [None, 'b', 'b', None],
                       [None, 'b', 'b', None],
                       [None, None, None, None]])


def beehive():
    return Grid.build([[None, None, None, None, None, None],
                       [None, None, 'b', 'b', None, None],
                       [None, 'b', None, None, 'b', None],
                       [None, None, 'b', 'b', None, None],
                       [None, None, None, None, None, None]])


def loaf():
    return Grid.build([[None, None, None, None, None, None],
                       [None, None, 'b', 'b', None, None],
                       [None, 'b', None, None, 'b', None],
                       [None, None, 'b', None, 'b', None],
                       [None, None, None, 'b', None, None],
                       [None, None, None, None, None, None]])


def boat():
    return Grid.build([[None, None, None, None, None],
                       [None, 'b', 'b', None, None],
                       [None, 'b', None, 'b', None],
                       [None, None, 'b', None, None],
                       [None, None, None, None, None]])


def tub():
    return Grid.build([[None, None, None, None, None],
                       [None, None, 'b', None, None],
                       [None, 'b', None, 'b', None],
                       [None, None, 'b', None, None],
                       [None, None, None, None, None]])


# Oscillators


def blinker():
    return Grid.build([[None, None, None, None, None],
                       [None, None, None, None, None],
                       [None, 'b', 'b', 'b', None],
                       [None, None, None , None, None],
                       [None, None, None, None, None]])


def toad():
    return Grid.build([[None, None, None, None, None, None],
                       [None, None, None, None, None, None],
                       [None, None, 'b', 'b', 'b', None],
                       [None, 'b', 'b', 'b', None, None],
                       [None, None, None, None, None, None],
                       [None, None, None, None, None, None]])


def beacon():
    return Grid.build([[None, None, None, None, None, None],
                       [None, 'b', 'b', None, None, None],
                       [None, 'b', None, None, None, None],
                       [None, None, None, None, 'b', None],
                       [None, None, None, 'b', 'b', None],
                       [None, None, None, None, None, None]])

# Spaceships


def glider():
    grid = Grid(20, 20)
    make_alive(grid, 0, 2)
    make_alive(grid, 1, 3)
    make_alive(grid, 2, 1)
    make_alive(grid, 2, 2)
    make_alive(grid, 2, 3)
    return grid


def lightweight_spaceship():
    grid = Grid(20, 20)
    make_alive(grid, 1, 2)
    make_alive(grid, 1, 3)
    make_alive(grid, 1, 4)
    make_alive(grid, 2, 1)
    make_alive(grid, 2, 4)
    make_alive(grid, 3, 4)
    make_alive(grid, 4, 4)
    make_alive(grid, 5, 1)
    make_alive(grid, 5, 3)
    return grid


# Others

def diehard():
    grid = Grid(30, 35)
    make_alive(grid, 11, 12)
    make_alive(grid, 12, 12)
    make_alive(grid, 12, 13)
    make_alive(grid, 16, 13)
    make_alive(grid, 17, 11)
    make_alive(grid, 17, 13)
    make_alive(grid, 18, 13)
    return grid


def engine():
    grid = Grid(50, 40)
    make_alive(grid, 21, 21)
    make_alive(grid, 21, 22)
    make_alive(grid, 21, 25)
    make_alive(grid, 22, 21)
    make_alive(grid, 22, 24)
    make_alive(grid, 23, 21)
    make_alive(grid, 23, 24)
    make_alive(grid, 23, 25)
    make_alive(grid, 24, 23)
    make_alive(grid, 25, 21)
    make_alive(grid, 25, 23)
    make_alive(grid, 25, 24)
    make_alive(grid, 25, 25)
    return grid











